Debian Bug report logs - #460504
dh_desktop/dh_icons madness

Package: general; Maintainer for general is debian-devel@lists.debian.org;

Reported by: Peter Eisentraut <peter_e@gmx.net>

Date: Sun, 13 Jan 2008 09:24:02 UTC

Severity: normal

Done: Holger Levsen <holger@layer-acht.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, <debian-devel@lists.debian.org>:
Bug#460504; Package general. Full text and rfc822 format available.

Acknowledgement sent to Peter Eisentraut <peter_e@gmx.net>:
New Bug report received and forwarded. Copy sent to <debian-devel@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Peter Eisentraut <peter_e@gmx.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: dh_desktop/dh_icons madness
Date: Sun, 13 Jan 2008 10:21:31 +0100
Package: general
Severity: normal

For a while now some folks have been going around asking various package
maintainers to inject dh_icons and/or dh_desktop calls into the package build
rules.  The basic argument appears to be that your package needs to do this so
that my desktop environment will work correctly.  I don't think this approach
has correct and sustainable principles.  And what is more, if some random third
packages or user environments dictate what other, unrelated packages have to do
to function with them, we will in practice never reach a state where everything
works.  Furthermore, if other desktop environments come up with their own
variants of icon caching of MIME file registration (since these are supposedly
Free Desktop standards) or perhaps completely new file registration
requirements, we will have an unmaintainable mess of competing implementations
of registration scripts, and thousands of packages stuck in a transition
somewhere between all of them.

It seems to me that, in principle, if some third package or user environment
wants something to be done for its own functional benefit, it should be its own
responsibility to arrange that, instead of bothering thousands of other
packages with it.  This appears to be the only robust and maintainable
approach.  On a technical level, the best approach would appear to be
implementing some sort of global dpkg postinst and postrm hooks.  Perhaps there
are other ideas, but the current approach needs to stop; it won't work.




Information forwarded to debian-bugs-dist@lists.debian.org, <debian-devel@lists.debian.org>:
Bug#460504; Package general. Full text and rfc822 format available.

Acknowledgement sent to Josselin Mouette <joss@debian.org>:
Extra info received and forwarded to list. Copy sent to <debian-devel@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 460504@bugs.debian.org (full text, mbox):

From: Josselin Mouette <joss@debian.org>
To: Peter Eisentraut <peter_e@gmx.net>, 460504@bugs.debian.org
Cc: debian-devel <debian-devel@lists.debian.org>
Subject: Re: Bug#460504: dh_desktop/dh_icons madness
Date: Sun, 13 Jan 2008 10:58:37 +0100
[Message part 1 (text/plain, inline)]
On dim, 2008-01-13 at 10:21 +0100, Peter Eisentraut wrote:
> For a while now some folks have been going around asking various package
> maintainers to inject dh_icons and/or dh_desktop calls into the package build
> rules.  The basic argument appears to be that your package needs to do this so
> that my desktop environment will work correctly.  I don't think this approach
> has correct and sustainable principles.  

Debian has always been about integration. Don’t you register your
documentation with doc-base so that your application integrates with
centralized documentation systems? Don’t you register your fonts with
defoma so that applications using it can actually see the fonts?

The same goes for desktop environments. You need to register your icons
so that they are correctly cached (icon loading is one of the biggest
performance issues on desktops), and to register your desktop files so
that the MIME registry works.

> And what is more, if some random third
> packages or user environments dictate what other, unrelated packages have to do
> to function with them, we will in practice never reach a state where everything
> works.  

It is not a random user environment. It is the accepted standard for the
three main desktops we are shipping.

> Furthermore, if other desktop environments come up with their own
> variants of icon caching of MIME file registration (since these are supposedly
> Free Desktop standards) or perhaps completely new file registration
> requirements, we will have an unmaintainable mess of competing implementations
> of registration scripts, and thousands of packages stuck in a transition
> somewhere between all of them.

But we are not talking about other desktop environments. If you were
asked to use dh_desktop, it is because your application *does* ship
Freedesktop .desktop files. If you were asked to use dh_icons, your
package *does* include icons in the Freedesktop directory hierarchy.

Furthermore, the update-mime-database and update-icon-caches commands
have very simple APIs which mean we can replace them easily with other
implementations if someone wants to design them.

> It seems to me that, in principle, if some third package or user environment
> wants something to be done for its own functional benefit, it should be its own
> responsibility to arrange that, instead of bothering thousands of other
> packages with it.

Is it the desktop environment’s or the package’s own functional benefit
to have the application launched when you click on a file of the related
type, or to have a visible icon? This is merely a philosophical
question.

> This appears to be the only robust and maintainable
> approach.  On a technical level, the best approach would appear to be
> implementing some sort of global dpkg postinst and postrm hooks.  Perhaps there
> are other ideas, but the current approach needs to stop; it won't work.

I thought dpkg triggers had been sufficiently advertised, but it seems
the mails haven’t reached the (deep ?) place you are living in.

-- 
 .''`.
: :' :      We are debian.org. Lower your prices, surrender your code.
`. `'       We will add your hardware and software distinctiveness to
  `-        our own. Resistance is futile.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <debian-devel@lists.debian.org>:
Bug#460504; Package general. Full text and rfc822 format available.

Acknowledgement sent to Peter Eisentraut <peter_e@gmx.net>:
Extra info received and forwarded to list. Copy sent to <debian-devel@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 460504@bugs.debian.org (full text, mbox):

From: Peter Eisentraut <peter_e@gmx.net>
To: Josselin Mouette <joss@debian.org>
Cc: 460504@bugs.debian.org
Subject: Re: Bug#460504: dh_desktop/dh_icons madness
Date: Sun, 13 Jan 2008 12:15:38 +0100
Josselin Mouette wrote:
> Debian has always been about integration. Don’t you register your
> documentation with doc-base so that your application integrates with
> centralized documentation systems?

I'm glad you bring up this comparison, but this is different.  If someone 
neglects to do doc-base registration, his package's documentation won't be 
usable in a nice way.  That directly affects the functionality of that 
package.  If someone doesn't do dh_icons or dh_desktop registration, nothing 
changes for that package.  It affects only users of whatever environment it 
is that appears to require this.

> It is not a random user environment. It is the accepted standard for the
> three main desktops we are shipping.

I assume you are talking about GNOME, Xfce, and KDE here.  KDE doesn't do any 
of this, so have doubts about the "accepted standard".  It seems silly to 
request all KDE-related packages to jump through hoops so they work with 
GNOME.

> Is it the desktop environment’s or the package’s own functional benefit
> to have the application launched when you click on a file of the related
> type, or to have a visible icon? This is merely a philosophical
> question.

It is to the desktop environment's benefit.  The package will work fine in 
other environments.  To pick a concrete example (bug #460449), if a GNOME 
user clicks on a kdissert file and things don't work, while they work just 
fine in KDE, then that is GNOME's problem, not kdissert's.

> I thought dpkg triggers had been sufficiently advertised, but it seems
> the mails haven’t reached the (deep ?) place you are living in.

They indeed haven't, but since they appear to have reached the (shallow ?) 
place you are living in, why not use them?




Information forwarded to debian-bugs-dist@lists.debian.org, <debian-devel@lists.debian.org>:
Bug#460504; Package general. Full text and rfc822 format available.

Acknowledgement sent to Josselin Mouette <joss@debian.org>:
Extra info received and forwarded to list. Copy sent to <debian-devel@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 460504@bugs.debian.org (full text, mbox):

From: Josselin Mouette <joss@debian.org>
To: Peter Eisentraut <peter_e@gmx.net>
Cc: 460504@bugs.debian.org
Subject: Re: Bug#460504: dh_desktop/dh_icons madness
Date: Sun, 13 Jan 2008 12:35:40 +0100
[Message part 1 (text/plain, inline)]
On dim, 2008-01-13 at 12:15 +0100, Peter Eisentraut wrote:
> Josselin Mouette wrote:
> > Debian has always been about integration. Don’t you register your
> > documentation with doc-base so that your application integrates with
> > centralized documentation systems?
> 
> I'm glad you bring up this comparison, but this is different.  If someone 
> neglects to do doc-base registration, his package's documentation won't be 
> usable in a nice way.  That directly affects the functionality of that 
> package.  If someone doesn't do dh_icons or dh_desktop registration, nothing 
> changes for that package.  It affects only users of whatever environment it 
> is that appears to require this.

You are completely wrong on this topic. If you don’t use dh_icons, the
icons shipped in your package won’t be available even to the application
itself. This is caused by a broken design for icon caches; because of
this design, icon caches are currently disabled. But when all packages
have been ported to update the cache, icons shipped in packages not
doing it won’t be available all (whether the application uses Qt or
GTK).

> > It is not a random user environment. It is the accepted standard for the
> > three main desktops we are shipping.
> 
> I assume you are talking about GNOME, Xfce, and KDE here.  KDE doesn't do any 
> of this, so have doubts about the "accepted standard".  It seems silly to 
> request all KDE-related packages to jump through hoops so they work with 
> GNOME.

KDE already uses the freedesktop standard for the menus. If it doesn’t
use it for the MIME registry as well, I would be very surprised if
upstream didn’t have at least plans to do that.

> It is to the desktop environment's benefit.  The package will work fine in 
> other environments.  To pick a concrete example (bug #460449), if a GNOME 
> user clicks on a kdissert file and things don't work, while they work just 
> fine in KDE, then that is GNOME's problem, not kdissert's.

In fact I am very surprised KDE doesn’t need the desktop database to be
up-to-date. Scanning all desktop files at runtime is deadly slow, so
even in this case it is a bad idea not to update the cache. Which is why
this is also probably affecting KDE users.

> > I thought dpkg triggers had been sufficiently advertised, but it seems
> > the mails haven’t reached the (deep ?) place you are living in.
> 
> They indeed haven't, but since they appear to have reached the (shallow ?) 
> place you are living in, why not use them?

If you had read them, you would also know this feature isn’t available
yet.

-- 
 .''`.
: :' :      We are debian.org. Lower your prices, surrender your code.
`. `'       We will add your hardware and software distinctiveness to
  `-        our own. Resistance is futile.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <debian-devel@lists.debian.org>:
Bug#460504; Package general. Full text and rfc822 format available.

Acknowledgement sent to Peter Eisentraut <peter_e@gmx.net>:
Extra info received and forwarded to list. Copy sent to <debian-devel@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 460504@bugs.debian.org (full text, mbox):

From: Peter Eisentraut <peter_e@gmx.net>
To: Josselin Mouette <joss@debian.org>
Cc: 460504@bugs.debian.org
Subject: Re: Bug#460504: dh_desktop/dh_icons madness
Date: Sun, 13 Jan 2008 13:12:20 +0100
Josselin Mouette wrote:
> You are completely wrong on this topic. If you don’t use dh_icons, the
> icons shipped in your package won’t be available even to the application
> itself.

I don't claim to know the technical details of this, but I don't have 
update-icon-caches installed and I have never had a missing icon.  So again I 
suspect that this is an issue particular to some other environment.  Which 
was my point.

> > > I thought dpkg triggers had been sufficiently advertised, but it seems
> > > the mails haven’t reached the (deep ?) place you are living in.
> >
> > They indeed haven't, but since they appear to have reached the (shallow
> > ?) place you are living in, why not use them?
>
> If you had read them, you would also know this feature isn’t available
> yet.

So the transitive closure of this discussion is that you are just idly 
rambling.  Thank you for your time.




Information forwarded to debian-bugs-dist@lists.debian.org, <debian-devel@lists.debian.org>:
Bug#460504; Package general. Full text and rfc822 format available.

Acknowledgement sent to Josselin Mouette <joss@debian.org>:
Extra info received and forwarded to list. Copy sent to <debian-devel@lists.debian.org>. Full text and rfc822 format available.

Message #30 received at 460504@bugs.debian.org (full text, mbox):

From: Josselin Mouette <joss@debian.org>
To: Peter Eisentraut <peter_e@gmx.net>
Cc: 460504@bugs.debian.org
Subject: Re: Bug#460504: dh_desktop/dh_icons madness
Date: Sun, 13 Jan 2008 13:32:09 +0100
[Message part 1 (text/plain, inline)]
On dim, 2008-01-13 at 13:12 +0100, Peter Eisentraut wrote:
> Josselin Mouette wrote:
> > You are completely wrong on this topic. If you don’t use dh_icons, the
> > icons shipped in your package won’t be available even to the application
> > itself.
> 
> I don't claim to know the technical details of this, but I don't have 
> update-icon-caches installed and I have never had a missing icon.  So again I 
> suspect that this is an issue particular to some other environment.  Which 
> was my point.

Nope, this works because you don’t have an icon cache. But if it gets
enabled (it often happens when you install something by hand or use an
Ubuntu package, and it *will* be the default in the future), icons not
in the cache won’t be visible.

> > If you had read them, you would also know this feature isn’t available
> > yet.
> 
> So the transitive closure of this discussion is that you are just idly 
> rambling.  Thank you for your time.

No, the conclusion is that you are grumbling about something that is
already underway, and that you are knowingly preventing your package to
integrate correctly without any justification but your own laziness.

-- 
 .''`.
: :' :      We are debian.org. Lower your prices, surrender your code.
`. `'       We will add your hardware and software distinctiveness to
  `-        our own. Resistance is futile.
[signature.asc (application/pgp-signature, inline)]

Blocking bugs of 460504 added: 17243, 68981, 215374, 217622, 248693, and 308285 Request was from Peter Eisentraut <petere@debian.org> to control@bugs.debian.org. (Thu, 31 Jan 2008 10:24:01 GMT) Full text and rfc822 format available.

Blocking bugs of 439717 added: 460504 Request was from Peter Eisentraut <petere@debian.org> to control@bugs.debian.org. (Thu, 31 Jan 2008 10:24:06 GMT) Full text and rfc822 format available.

Blocking bugs of 432851 added: 460504 Request was from Peter Eisentraut <petere@debian.org> to control@bugs.debian.org. (Thu, 31 Jan 2008 10:24:07 GMT) Full text and rfc822 format available.

Reply sent to Holger Levsen <holger@layer-acht.org>:
You have taken responsibility. (Sat, 20 Sep 2008 12:51:09 GMT) Full text and rfc822 format available.

Notification sent to Peter Eisentraut <peter_e@gmx.net>:
Bug acknowledged by developer. (Sat, 20 Sep 2008 12:51:10 GMT) Full text and rfc822 format available.

Message #41 received at 460504-done@bugs.debian.org (full text, mbox):

From: Holger Levsen <holger@layer-acht.org>
To: 460504-done@bugs.debian.org
Subject: not a bug
Date: Sat, 20 Sep 2008 12:39:57 +0200
[Message part 1 (text/plain, inline)]
Hi,

as explained in the bug report, this is not a bug, but a feature (we 
want .desktop files and icons), thus closing.


regards,
	Holger
[Message part 2 (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 19 Oct 2008 07:25:19 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 17:04:19 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.